--!parent
--!encoding=utf-8

--****************************************************************************
-- @file      LSW CORE LIB: FILESYSTEM
-- @author    Valentin Schmidt
-- @version   0.1
-- @requires  xtra("FileXtra4")
--****************************************************************************

--property ancestor
property _fx

----------------------------------------
-- @constructor
----------------------------------------
on new (me)
  
  me.$.loadXtras(me.libdir, ["FileXtra4.x32"], ["FileXtra4.xtra"])
  
  -- me.ancestor = xtra("FileXtra4").new()
  me._fx = xtra("FileXtra4").new()
  
  return me
end

  --fx_FileExists object me, string fileName
--fx_FileIsLink object me, string fileName
  --fx_FileRename object me, string oldName, string newName
  --fx_FileDelete object me, string fileName
--fx_FileRecycle object me, string fileName
  --fx_FileCopy object me, string fromFName, string toFName
  --fx_FileMove object me, string fromFName, string toFName

-- files

on fileCopy (me, fromFn, toFn)
  return me._fx.fx_FileCopy(fromFn, toFn)
end

on fileDelete (me, fn)
  return me._fx.fx_FileDelete(fn)
end

on fileExists (me, fn)
  return me._fx.fx_FileExists(fn)
end

on fileMove (me, fromFn, toFn)
  return me._fx.fx_FileMove(fromFn, toFn)
end

on fileRecycle (me, fn)
  return me._fx.fx_FileRecycle(fn)
end

on fileRename (me, fromFn, toFn)
  return me._fx.fx_FileRename(fromFn, toFn)
end

-- folders

on folderList (me, folderName)
  return me._fx.fx_FolderToList(folderName)
end
