--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID,PrinterID)
on new (me,p1,p2)
  me._class = #PrintPreviewDialog
  me.ancestor = $.include($.Qt.libDir&"/classes/iDialog.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  if ilk(p2)=#instance then p2 = p2._id
  me._id = $.Qt._qx.newWidget(me._class,p1,p2)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"/classes/iDialog.ls").new()
	obj._class = #PrintPreviewDialog
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- setPictures (PictureIDs)
on setPictures (me,p1)
  $.Qt._qx.callWidget(me._id,#setPictures,p1)
end

-- setProvider (WebWiewID|TextEditID|PlainTextEditID)
on setProvider (me,p1)
  if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callWidget(me._id,#setProvider,p1)
end

----------------------------------------
-- STATIC
----------------------------------------

-- show (WidgetID,list|WebWiewID,*PrinterID)
on show (scr,p1,p2,p3)
  if ilk(p1)=#instance then p1 = p1._id
  if ilk(p2)=#instance then p2 = p2._id
  if ilk(p3)=#instance then p3 = p3._id
  $.Qt._qx.callWidget(#PrintPreviewDialog,#show,p1,p2,p3)
end

----------------------------------------
-- SIGNALS
----------------------------------------

-- paintRequested -> PrinterID
on paintRequested(me,id,p1)
  me._detach(#paintRequested,id,p1)
end

-- accepted
on accepted(me,id)
  me._detach(#accepted,id)
end

-- finished -> int
on finished(me,id,p1)
  me._detach(#finished,id,p1)
end

-- rejected
on rejected(me,id)
  me._detach(#rejected,id)
end

