--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #NetworkAccessManager
  me.ancestor = $.include($.Qt.libDir&"/classes/iObject.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newObject(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"/classes/iObject.ls").new()
	obj._class = #NetworkAccessManager
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- customRequest (string,string,*propList) -> NetworkReplyID
on customRequest (me,p1,p2,p3)
  obj = $.Qt.NetworkReply._make($.Qt._qx.callObject(me._id,#customRequest,p1,p2,p3))
  me._children.add(obj)
  return obj
end

-- delete (string,*propList) -> NetworkReplyID
on delete_ (me,p1,p2)
  obj = $.Qt.NetworkReply._make($.Qt._qx.callObject(me._id,#delete,p1,p2))
  me._children.add(obj)
  return obj
end

-- get (string,*propList) -> NetworkReplyID
on get (me,p1,p2)
  obj = $.Qt.NetworkReply._make($.Qt._qx.callObject(me._id,#get,p1,p2))
  me._children.add(obj)
  return obj
end

-- objectName () -> string
on objectName (me)
  return $.Qt._qx.callObject(me._id,#objectName)
end

-- post (string,string,*propList) -> NetworkReplyID
on post (me,p1,p2,p3)
  obj = $.Qt.NetworkReply._make($.Qt._qx.callObject(me._id,#post,p1,p2,p3))
  me._children.add(obj)
  return obj
end

-- put (string,string,*propList) -> NetworkReplyID
on put_ (me,p1,p2,p3)
  obj = $.Qt.NetworkReply._make($.Qt._qx.callObject(me._id,#put,p1,p2,p3))
  me._children.add(obj)
  return obj
end

-- setCacheDirectory (string)
on setCacheDirectory (me,p1)
  $.Qt._qx.callObject(me._id,#setCacheDirectory,p1)
end

-- setCookieJar (int NetworkCookieJarID)
on setCookieJar (me,p1)
  if ilk(p1)=#instance then
    p1 = p1._id
  end if
  $.Qt._qx.callObject(me._id,#setCookieJar,p1)
end

-- setObjectName (string)
on setObjectName (me,p1)
  $.Qt._qx.callObject(me._id,#setObjectName,p1)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

