--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #ComboBox
  me.ancestor = $.include($.Qt.libDir&"/classes/iWidget.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"/classes/iWidget.ls").new()
	obj._class = #ComboBox
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- addItem (string,*string)
on addItem (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#addItem,p1,p2)
end

-- count () -> int
on count (me)
  return $.Qt._qx.callWidget(me._id,#count)
end

-- currentIndex () -> int
on currentIndex (me)
  return $.Qt._qx.callWidget(me._id,#currentIndex)
end

-- currentText () -> string
on currentText (me)
  return $.Qt._qx.callWidget(me._id,#currentText)
end

-- findText (string,*int) -> int
on findText (me,p1,p2)
  return $.Qt._qx.callWidget(me._id,#findText,p1,p2)
end

-- getItemData (int) -> string
on getItemData (me,p1)
  return $.Qt._qx.callWidget(me._id,#getItemData,p1)
end

-- getItemText (int) -> string
on getItemText (me,p1)
  return $.Qt._qx.callWidget(me._id,#getItemText,p1)
end

-- insertItem (int,string,string,*string|image)
on insertItem (me,p1,p2,p3,p4)
  $.Qt._qx.callWidget(me._id,#insertItem,p1,p2,p3,p4)
end

-- removeItem (int)
on removeItem (me,p1)
  $.Qt._qx.callWidget(me._id,#removeItem,p1)
end

-- setCurrentIndex (int)
on setCurrentIndex (me,p1)
  $.Qt._qx.callWidget(me._id,#setCurrentIndex,p1)
end

-- setEditable (bool)
on setEditable (me,p1)
  $.Qt._qx.callWidget(me._id,#setEditable,p1)
end

-- setEditText (string)
on setEditText (me,p1)
  $.Qt._qx.callWidget(me._id,#setEditText,p1)
end

-- setItemData (int,string)
on setItemData (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#setItemData,p1,p2)
end

-- setItemText (int,string)
on setItemText (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#setItemText,p1,p2)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- activated -> string
on activated(me,id,p1)
  me._detach(#activated,id,p1)
end

-- currentIndexChanged -> int
on currentIndexChanged(me,id,p1)
  me._detach(#currentIndexChanged,id,p1)
end

