--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #StackedWidget
  me.ancestor = $.include($.Qt.libDir&"/classes/iWidget.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"/classes/iWidget.ls").new()
	obj._class = #StackedWidget
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- addWidget (WidgetID) -> int
on addWidget (me,p1)
  if ilk(p1)=#instance then 
  	me._children.add(p1) -- ???
  	p1 = p1._id
  end if
  return $.Qt._qx.callWidget(me._id,#addWidget,p1)
end

-- count () -> int
on count (me)
  return $.Qt._qx.callWidget(me._id,#count)
end

-- currentIndex () -> int
on currentIndex (me)
  return $.Qt._qx.callWidget(me._id,#currentIndex)
end

-- indexOf (int) -> int
on indexOf (me,p1)
  return $.Qt._qx.callWidget(me._id,#indexOf,p1)
end

-- insertWidget (int,WidgetID) -> int
on insertWidget (me,p1,p2)
	if ilk(p2)=#instance then p2 = p2._id
  return $.Qt._qx.callWidget(me._id,#insertWidget,p1,p2)
end

-- removeWidget (WidgetID)
on removeWidget (me,p1)
	if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callWidget(me._id,#removeWidget,p1)
end

-- setCurrentIndex (int)
on setCurrentIndex (me,p1)
  $.Qt._qx.callWidget(me._id,#setCurrentIndex,p1)
end

-- setCurrentWidget (WidgetID)
on setCurrentWidget (me,p1)
	if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callWidget(me._id,#setCurrentWidget,p1)
end

-- widgetAt (int) -> WidgetID
on widgetAt (me,p1)
  obj = $.Qt.Widget._make($.Qt._qx.callWidget(me._id,#widgetAt,p1))
  me._children.add(obj)
  return obj
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- currentChanged -> int
on currentChanged(me,id,p1)
  me._detach(#currentChanged,id,p1)
end

-- widgetRemoved -> int
on widgetRemoved(me,id,p1)
  me._detach(#widgetRemoved,id,p1)
end

